diff --git a/lib/hive/git_ops.rb b/lib/hive/git_ops.rb
index 6b193db..1d078ae 100644
--- a/lib/hive/git_ops.rb
+++ b/lib/hive/git_ops.rb
@@ -1,5 +1,6 @@
 require "open3"
 require "fileutils"
+require "hive"
 require "hive/stages"
 
 module Hive
@@ -8,12 +9,23 @@ module Hive
 
     attr_reader :project_root
 
-    def initialize(project_root)
+    def initialize(project_root, state_dir_basename: nil)
       @project_root = File.expand_path(project_root)
+      # Tests may pin the basename; production resolves dynamically so a
+      # pre-rename `.hive-state` tree keeps working after the upgrade.
+      @state_dir_basename_override = state_dir_basename
+    end
+
+    def state_dir_basename
+      @state_dir_basename_override || ProjectDirs.resolve(@project_root)
     end
 
     def hive_state_path
-      File.join(@project_root, ".hive-state")
+      File.join(@project_root, state_dir_basename)
+    end
+
+    def legacy_state_tree?
+      state_dir_basename == LEGACY_PROJECT_DIR
     end
 
     def default_branch
@@ -113,16 +125,24 @@ module Hive
       run_git!("-C", @project_root, "worktree", "add", hive_state_path, HIVE_BRANCH)
     end
 
+    # Master .gitignore must exclude BOTH scaffold roots: the canonical
+    # `/.hive/` and the legacy `/.hive-state/` (a checkout that upgraded
+    # still carries the old pattern; a fresh init never wants to commit
+    # either). Idempotent — only missing patterns are appended, and only
+    # when at least one is new does it stage + commit.
+    SCAFFOLD_GITIGNORE_PATTERNS = ["/#{PROJECT_DIR}/", "/#{LEGACY_PROJECT_DIR}/"].freeze
+
     def add_hive_state_to_master_gitignore!
       gitignore_path = File.join(@project_root, ".gitignore")
-      pattern = "/.hive-state/"
       existing = File.exist?(gitignore_path) ? File.read(gitignore_path) : ""
-      return :already if existing.split("\n").include?(pattern)
+      lines = existing.split("\n")
+      missing = SCAFFOLD_GITIGNORE_PATTERNS - lines
+      return :already if missing.empty?
 
       separator = existing.empty? || existing.end_with?("\n") ? "" : "\n"
-      File.write(gitignore_path, "#{existing}#{separator}#{pattern}\n")
+      File.write(gitignore_path, "#{existing}#{separator}#{missing.join("\n")}\n")
       run_git!("-C", @project_root, "add", ".gitignore")
-      run_git!("-C", @project_root, "commit", "-m", "chore: ignore .hive-state worktree")
+      run_git!("-C", @project_root, "commit", "-m", "chore: ignore #{PROJECT_DIR} state worktree")
       :added
     end
 
diff --git a/lib/hive/install_receipt.rb b/lib/hive/install_receipt.rb
new file mode 100644
index 0000000..2e41ad8
--- /dev/null
+++ b/lib/hive/install_receipt.rb
@@ -0,0 +1,142 @@
+require "fileutils"
+require "open3"
+require "hive"
+require "hive/paths"
+require "yaml"
+
+module Hive
+  # Per-channel install receipt (plan figure-out-way-to-install-
+  # 260513-4a0a U6/U7): a tiny YAML document at ~/.config/hive/install.yml
+  # written by each distribution channel at install time so `hive update`
+  # and `hive uninstall` can delegate to the channel's native tooling and
+  # never swap binaries behind a package manager.
+  #
+  #   channel:      brew | aur | script   (closed enum)
+  #   version:      v0.1.0                (tag of the installed release)
+  #   command_name: hive | hv             (Apache-Hive collision fallback)
+  #   binary_path:  /opt/homebrew/bin/hive
+  #   installed_at: ISO8601
+  #
+  # Writers outside Ruby (Homebrew post_install, AUR .install hook,
+  # install.sh) emit exactly this shape; the loader tolerates their
+  # idempotent rewrites.
+  module InstallReceipt
+    VALID_CHANNELS = %w[brew aur script].freeze
+
+    class InvalidError < Hive::ConfigError; end
+
+    module_function
+
+    def path
+      Hive::Paths.install_receipt_path
+    end
+
+    def write!(channel:, version:, command_name: "hive", binary_path: nil,
+               release_base: nil, installed_at: Time.now.utc)
+      raise InvalidError, "unknown install channel #{channel.inspect}" unless VALID_CHANNELS.include?(channel)
+
+      doc = {
+        "channel" => channel,
+        "version" => version.to_s,
+        "command_name" => command_name,
+        "binary_path" => binary_path,
+        "release_base" => release_base,
+        "installed_at" => installed_at.utc.iso8601
+      }.compact
+
+      FileUtils.mkdir_p(File.dirname(path))
+      File.open(path, File::WRONLY | File::CREAT | File::TRUNC, 0o644) do |f|
+        f.write(doc.to_yaml)
+      end
+      doc
+    rescue Errno::EACCES, Errno::EROFS, Errno::ENOSPC => e
+      raise Hive::ConfigError, "could not write install receipt at #{path}: #{e.message}"
+    end
+
+    # Returns the parsed Hash when a well-formed receipt exists, nil when
+    # absent, and raises InvalidError for malformed content so callers can
+    # surface a loud repair hint instead of guessing channels.
+    def read
+      return nil unless File.file?(path)
+
+      data = YAML.safe_load(File.read(path))
+      raise InvalidError, "#{path} must be a mapping" unless data.is_a?(Hash)
+
+      validate!(data)
+      data
+    rescue Psych::Exception => e
+      raise InvalidError, "#{path} is not valid YAML: #{e.message}"
+    end
+
+    def validate!(data)
+      return if data.nil?
+
+      unless VALID_CHANNELS.include?(data["channel"])
+        raise InvalidError,
+              "install receipt #{path} has invalid channel #{data['channel'].inspect} " \
+              "(expected one of #{VALID_CHANNELS.join(', ')})"
+      end
+      if data["version"] && !data["version"].to_s.match?(/\Av?\d+\.\d+\.\d+/)
+        raise InvalidError, "install receipt #{path} has malformed version #{data['version'].inspect}"
+      end
+    end
+
+    # Receipt if present; otherwise best-effort channel inference from the
+    # filesystem (plan U9 allows pacman/prefix fallbacks when a channel's
+    # post-install hook couldn't write). Returns [data_or_nil, source]
+    # where source is :receipt | :detected_brew | :detected_aur |
+    # :detected_script | :none.
+    def resolve(binary_path = found_binary_path)
+      if (receipt = read)
+        return [ receipt, :receipt ]
+      end
+
+      detected = detect_fallback(binary_path)
+      return detected ? [ detected, :"detected_#{detected['channel']}" ] : [ nil, :none ]
+    end
+
+    def found_binary_path
+      command = ENV["HIVE_COMMAND_NAME"] || "hive"
+      ENV.fetch("PATH", "").split(File::PATH_SEPARATOR)
+         .map { |d| File.join(d, command) }
+         .find { |p| File.file?(p) }
+    end
+
+    # Heuristics only consulted when no receipt exists. Each probe is
+    # cheap, side-effect-free, and non-fatal.
+    def detect_fallback(binary_path)
+      bp = binary_path.to_s
+      return nil if bp.empty?
+
+      if File.realpath(bp)
+        real = begin
+          File.realpath(bp)
+        rescue StandardError
+          bp
+        end
+        # Brew prefixes: /opt/homebrew (Apple Silicon), /usr/local (Intel).
+        if real.start_with?("/opt/homebrew/", "/usr/local/Homebrew/") ||
+           Dir.glob("#{real.gsub(%r{/bin/.*\z}, '')}/../../../*HOMEBREW*").any?
+          return { "channel" => "brew", "command_name" => File.basename(bp) }
+        end
+
+        out, _err, status = Open3.capture3("pacman", "-Qo", bp)
+        if status.success? && out.include?("hive-bin")
+          return { "channel" => "aur", "command_name" => File.basename(bp) }
+        end
+
+        script_root = Hive::Paths.data_dir
+        return { "channel" => "script", "command_name" => File.basename(bp) } if
+          real.start_with?(script_root) || File.exist?(File.join(script_root, ".hive-script-install"))
+      end
+      nil
+    end
+
+    def forget!
+      return false unless File.exist?(path)
+
+      FileUtils.rm_f(path)
+      true
+    end
+  end
+end
diff --git a/lib/hive/paths.rb b/lib/hive/paths.rb
new file mode 100644
index 0000000..e675a17
--- /dev/null
+++ b/lib/hive/paths.rb
@@ -0,0 +1,131 @@
+module Hive
+  # Single source of truth for every on-disk location Hive reads or
+  # writes outside a project checkout. Implements the XDG best-practice
+  # layout adopted for packaged installs (plan
+  # figure-out-way-to-install-260513-4a0a, U1):
+  #
+  #   config:  ~/.config/hive/          (global config.yml, install.yml)
+  #   state:   ~/.local/state/hive/    (daemon PID/logs, bot PID/logs)
+  #   data:    ~/.local/share/hive/     (shared assets for packaged builds)
+  #   cache:   ~/.cache/hive/
+  #
+  # Env overrides, highest precedence first:
+  #   HIVE_HOME          — full sandbox override used by the test suite
+  #                        and dev checkouts: every directory below roots
+  #                        inside $HIVE_HOME so nothing leaks to $HOME.
+  #   XDG_CONFIG_HOME / XDG_STATE_HOME / XDG_DATA_HOME / XDG_CACHE_HOME —
+  #                      standard per-suffix overrides.
+  #
+  # Legacy layout: before XDG adoption the global home was ~/Dev/hive
+  # (the source checkout doubled as the config home). Paths exposes
+  # `legacy_hive_home` so Hive::Config can perform the one-time
+  # migration (move, with a printed notice) described there.
+  module Paths
+    module_function
+
+    # Returns true when running inside an explicit HIVE_HOME sandbox
+    # (tests, forced dev isolation). Under a sandbox all four directories
+    # collapse inside $HIVE_HOME so a tmpdir fully contains every artifact.
+    def sandboxed?
+      !(ENV["HIVE_HOME"].to_s.empty?)
+    end
+
+    def xdg_base(env_var, default_suffix)
+      raw = ENV[env_var]
+      base = raw.to_s.empty? ? File.join(Dir.home, default_suffix) : File.expand_path(raw)
+      base.freeze
+    end
+
+    # Global config home for the registry + install receipts.
+    def config_dir
+      return ENV["HIVE_HOME"].dup if sandboxed?
+
+      File.join(xdg_base("XDG_CONFIG_HOME", ".config"), "hive")
+    end
+
+    # Per-user runtime state (PIDs, logs). Never holds documents worth
+    # keeping; safe to wipe between boots.
+    def state_dir
+      return ENV["HIVE_HOME"].dup if sandboxed?
+
+      File.join(xdg_base("XDG_STATE_HOME", ".local/state"), "hive")
+    end
+
+    # Shared assets installed by the packaging channels (templates etc.).
+    # Also serves as the packaged-tarball extraction root for the bash
+    # one-liner installer (U10).
+    def data_dir
+      return File.join(ENV["HIVE_HOME"], "share") if sandboxed?
+
+      File.join(xdg_base("XDG_DATA_HOME", ".local/share"), "hive")
+    end
+
+    def cache_dir
+      return File.join(ENV["HIVE_HOME"], "cache") if sandboxed?
+
+      File.join(xdg_base("XDG_CACHE_HOME", ".cache"), "hive")
+    end
+
+    # Pre-XDG location: the source checkout doubled as the config home.
+    def legacy_hive_home
+      File.expand_path("~/Dev/hive")
+    end
+
+    # ── Daemon runtime files ──────────────────────────────────────────
+    # Inside a HIVE_HOME sandbox the historical filenames are preserved
+    # (".daemon.pid" at the sandbox root) so existing tooling and the
+    # long-running test suite keep their exact expectations. On the real
+    # XDG layout the PID lives as plain `daemon.pid` under the state dir
+    # and logs under <state>/logs/.
+    def daemon_pid_file
+      if sandboxed?
+        File.join(config_dir, ".daemon.pid")
+      else
+        File.join(state_dir, "daemon.pid")
+      end
+    end
+
+    def daemon_log_dir
+      if sandboxed?
+        File.join(config_dir, "logs")
+      else
+        File.join(state_dir, "logs")
+      end
+    end
+
+    def daemon_log_file
+      File.join(daemon_log_dir, "daemon.log")
+    end
+
+    # ── Telegram bot runtime files ────────────────────────────────────
+    def bot_pid_file
+      if sandboxed?
+        File.join(config_dir, ".bot.pid")
+      else
+        File.join(state_dir, "bot.pid")
+      end
+    end
+
+    def bot_log_file
+      if sandboxed?
+        File.join(config_dir, "logs", "bot.log")
+      else
+        File.join(state_dir, "logs", "bot.log")
+      end
+    end
+
+    def bot_last_seen_file
+      if sandboxed?
+        File.join(config_dir, ".bot.last_seen_update_id")
+      else
+        File.join(state_dir, "bot.last_seen_update_id")
+      end
+    end
+
+    # Path of the per-channel install receipt written by brew/AUR/install.sh
+    # and consumed by `hive update` / `hive uninstall` (U6/U7).
+    def install_receipt_path
+      File.join(config_dir, "install.yml")
+    end
+  end
+end
diff --git a/lib/hive/service.rb b/lib/hive/service.rb
new file mode 100644
index 0000000..2a08c95
--- /dev/null
+++ b/lib/hive/service.rb
@@ -0,0 +1,297 @@
+require "erb"
+require "fileutils"
+require "open3"
+require "hive"
+require "hive/paths"
+
+module Hive
+  module Service
+    # Per-user daemon service registration (plan
+    # figure-out-way-to-install-260513-4a0a U5 / R10 / R18):
+    #
+    #   * macOS → launchd agent plist at ~/Library/LaunchAgents/
+    #     io.github.ivankuznetsov.hive.plist (KeepAlive on-failure semantics)
+    #   * Linux (systemd user session) → ~/.config/systemd/user/hive.service
+    #     with Restart=on-failure
+    #   * Linux without systemd (WSL2, minimal containers) → detected and
+    #     reported with a hint instead of failing (Risk #5).
+    #
+    # Never silent-autostarts: registration applies whatever choice the
+    # operator made (`start_now` | `register_only` | `skip`), and the
+    # non-TTY default is register_only. The unit/plist execs
+    # `<bin> daemon start`, i.e. the foreground dispatcher loop, so the
+    # supervisor owns restarts and logs land in Hive::Paths.state_dir.
+    LABEL = "io.github.ivankuznetsov.hive".freeze
+
+    # Choices returned by RegisterPrompt#ask.
+    START_NOW     = "start_now".freeze
+    REGISTER_ONLY = "register_only".freeze
+    SKIP          = "skip".freeze
+
+    module_function
+
+    def supported?
+      case platform
+      when :macos then true
+      when :linux then systemd_user_session?
+      else false
+      end
+    end
+
+    def unsupported_reason
+      case platform
+      when :macos then nil
+      when :linux
+        "systemd --user is not available here; if this is WSL2, enable systemd in /etc/wsl.conf " \
+          "(`[boot]\\nsystemd=true`) or run `hive daemon start --detach` manually"
+      else
+        "unsupported platform #{platform.inspect}; manage the daemon manually via `hive daemon start --detach`"
+      end
+    end
+
+    def platform
+      RUBY_PLATFORM.include?("darwin") ? :macos : :linux
+    end
+
+    def systemd_user_session?
+      # systemctl exists AND a reachable user bus. Cheap probe keeps the
+      # check hermetic (no D-Bus calls).
+      systemctl_on_path && File.directory?(run_user_dir || "")
+    end
+
+    def systemctl_on_path
+      ENV.fetch("PATH", "").split(File::PATH_SEPARATOR)
+         .any? { |d| File.executable?(File.join(d, "systemctl")) }
+    end
+
+    def run_user_dir
+      dir = "/run/user/#{Process.uid}"
+      File.directory?(dir) ? dir : nil
+    end
+
+    def wsl2?
+      version = begin
+        File.read("/proc/version").downcase
+      rescue StandardError
+        ""
+      end
+      version.include?("microsoft")
+    end
+
+    def bin_path
+      @bin_path ||= ENV["HIVE_SERVICE_BIN"] || resolve_bin || File.expand_path($PROGRAM_NAME)
+    end
+
+    def resolve_bin
+      ENV.fetch("PATH", "").split(File::PATH_SEPARATOR)
+         .map { |d| File.join(d, command_name) }
+         .find { |p| File.file?(p) && File.executable?(p) }
+    end
+
+    def command_name
+      ENV["HIVE_COMMAND_NAME"] || "hive"
+    end
+
+    # ── Template rendering ──────────────────────────────────────────────
+
+    def render(kind, bindings = {})
+      template_path = File.expand_path("../../templates/service/#{kind}", __dir__)
+      ERB.new(File.read(template_path), trim_mode: "-").result_with_hash(bindings)
+    end
+
+    def template_bindings
+      {
+        label: LABEL,
+        bin_path: bin_path,
+        command_name: command_name,
+        state_dir: Hive::Paths.state_dir,
+        log_file: Hive::Paths.daemon_log_file
+      }
+    end
+
+    # ── Registration ────────────────────────────────────────────────────
+
+    # Installs the unit/plist (idempotent overwrite) and optionally starts
+    # it now. Returns a Hash describing what happened so callers can print
+    # a summary. Raises Hive::Service::Unsupported on impossible platforms;
+    # callers are expected to rescue and degrade to a printed hint.
+    class Unsupported < Hive::Error
+      def exit_code
+        Hive::ExitCodes::GENERIC
+      end
+    end
+
+    def register!(choice)
+      raise Unsupported, (unsupported_reason || "service registration unsupported") unless supported?
+
+      paths = manifest_paths
+      FileUtils.mkdir_p(File.dirname(paths[:manifest]))
+
+      case platform
+      when :macos
+        File.write(paths[:manifest], render("io.github.ivankuznetsov.hive.plist.erb", template_bindings))
+      when :linux
+        File.write(paths[:manifest], render("hive.service.erb", template_bindings))
+      end
+
+      if choice == START_NOW
+        start_now!
+      elsif choice == REGISTER_ONLY
+        reload!
+      end
+
+      { manifest: paths[:manifest], started_now: choice == START_NOW }
+    end
+
+    def manifest_paths
+      case platform
+      when :macos
+        base = sandboxed? ? File.join(Hive::Paths.state_dir, "Library", "LaunchAgents")
+                          : File.expand_path("~/Library/LaunchAgents")
+        { manifest: File.join(base, "#{LABEL}.plist"), manager: "launchd" }
+      when :linux
+        base = sandboxed? ? File.join(Hive::Paths.state_dir, "systemd", "user")
+                          : File.expand_path("~/.config/systemd/user")
+        { manifest: File.join(base, "#{command_name}.service"), manager: "systemd --user" }
+      else
+        { manifest: nil, manager: nil }
+      end
+    end
+
+    # Under an explicit HIVE_HOME (tests / forced dev isolation) the service
+    # manifests live INSIDE the sandbox tree instead of $HOME so nothing
+    # leaks to the operator's real launchd/systemd config.
+    def sandboxed?
+      Hive::Paths.sandboxed?
+    end
+
+    def registered?
+      return false unless supported?
+
+      path = manifest_paths[:manifest]
+      return false unless path && File.exist?(path)
+
+      return true if platform == :macos
+
+      # systemd: presence of the file is enough for "registered but maybe
+      # not enabled"; enabledness is probed separately via active?
+      true
+    end
+
+    def active?
+      return false unless supported?
+
+      _out, err, status =
+        if platform == :macos
+          Open3.capture3("launchctl", "print", "gui/#{Process.uid}/#{LABEL}")
+        else
+          Open3.capture3("systemctl", "--user", "is-active", "#{command_name}.service")
+        end
+      status.success? && !err.to_s.include?("could not find")
+    rescue StandardError
+      false
+    end
+
+    def start_now!
+      if platform == :macos
+        bootstrap_and_kickstart
+      else
+        run!("systemctl --user daemon-reload")
+        run!("systemctl", "--user", "enable", "--now", "#{command_name}.service")
+      end
+    end
+
+    def reload!
+      return unless platform == :linux
+
+      run!("systemctl", "--user", "daemon-reload")
+    end
+
+    def bootstrap_and_kickstart
+      plist = manifest_paths[:manifest]
+      # Ignore 'already bootstrapped' failures; kickstart below is the
+      # authoritative start action.
+      Open3.capture3("launchctl", "bootstrap", "gui/#{Process.uid}", plist)
+      run!("launchctl", "kickstart", "-k", "gui/#{Process.uid}/#{LABEL}")
+    end
+
+    def unload!
+      return false unless registered?
+
+      if platform == :macos
+        Open3.capture3("launchctl", "bootout", "gui/#{Process.uid}/#{LABEL}")
+      else
+        run!("systemctl", "--user", "disable", "--now", "#{command_name}.service") rescue nil
+        Open3.capture3("systemctl", "--user", "stop", "#{command_name}.service")
+      end
+      true
+    end
+
+    def remove_manifest!
+      path = manifest_paths[:manifest]
+      return false unless path && File.exist?(path)
+
+      FileUtils.rm_f(path)
+      true
+    end
+
+    def run!(*cmd)
+      out, err, status = Open3.capture3(*cmd)
+      unless status.success?
+        raise Hive::Error, "service command failed (#{cmd.shelljoin}): #{err.strip.empty? ? out.strip : err.strip}"
+      end
+
+      out
+    end
+  end
+
+  # Operator-facing prompt, isolated from Init::Prompts so its answer sits
+  # outside the long-standing scripted token budget of that flow (R10).
+  # Non-TTY input defaults to REGISTER_ONLY — the service IS registered so
+  # it survives reboots under the OS supervisor's control, but nothing is
+  # silently started ("never silent autostart", "never installed-disabled-
+  # only").
+  class ServiceRegisterPrompt
+    def initialize(input: $stdin, output: $stderr)
+      @input = input
+      @output = output
+    end
+
+    def ask
+      unless @input.respond_to?(:tty?) && @input.tty?
+        banner
+        @output.puts "  non-interactive shell → registering only (not started); start later with:"
+        @output.puts "    #{Service.command_name} daemon start --detach   # or reboot"
+        return Service::REGISTER_ONLY
+      end
+
+      banner
+      loop do
+        @output.print "Enable and start the hive daemon service now? [start/register/skip]: "
+        @output.flush
+        raw = @input.gets
+        # EOF mid-question = operator disconnected; never autostart, and
+        # don't abort a completed init over an optional post-scaffold step.
+        return Service::SKIP if raw.nil?
+
+        case raw.strip.downcase
+        when "", "start"              then return Service::START_NOW
+        when "register"               then return Service::REGISTER_ONLY
+        when "skip"                   then return Service::SKIP
+        end
+        @output.puts "  please answer start, register, or skip"
+      end
+    end
+
+    private
+
+    def banner
+      @output.puts ""
+      @output.puts "Daemon service — keep the pipeline advancing between logins."
+      @output.puts "  Registers a per-user #{Service.platform == :macos ? 'launchd agent' : 'systemd --user unit'}" \
+                   " that runs `#{Service.command_name} daemon start`."
+      @output.puts "  Restart-on-failure is owned by the service manager; never swapped in place."
+      @output.puts "  Nothing is started unless you choose 'start'."
+    end
+  end
+end
diff --git a/lib/hive/stages/base.rb b/lib/hive/stages/base.rb
index 7d19d3c..30d8c05 100644
--- a/lib/hive/stages/base.rb
+++ b/lib/hive/stages/base.rb
@@ -2,7 +2,9 @@ require "erb"
 require "fileutils"
 require "securerandom"
 require "time"
+require "hive"
 require "hive/agent"
+require "hive/assets"
 require "hive/agent_profiles"
 
 module Hive
@@ -25,6 +27,13 @@ module Hive
 
       def render(template_name, bindings_obj)
         path = File.expand_path("../../../templates/#{template_name}", __dir__)
+        # Packaged builds (U3) may ship shared assets outside the app
+        # tree (XDG data dir / HIVE_ASSETS_DIR); prefer the operator-
+        # visible copy when it exists, else fall back to the repo layout.
+        if (shared = Hive::Assets.dir_for("templates"))
+          shared_path = File.join(shared, template_name)
+          path = shared_path if File.exist?(shared_path)
+        end
         ERB.new(File.read(path), trim_mode: "-").result(bindings_obj.binding_for_erb)
       end
 
diff --git a/lib/hive/task.rb b/lib/hive/task.rb
index c98cf88..d784293 100644
--- a/lib/hive/task.rb
+++ b/lib/hive/task.rb
@@ -1,4 +1,5 @@
 require "yaml"
+require "hive"
 require "hive/stages"
 
 module Hive
@@ -14,7 +15,11 @@ module Hive
       "finalize" => "pr.md",
       "done" => "task.md"
     }.freeze
-    PATH_RE = %r{\A(?<root>.+)/(?<state_dir>\.hive-state)/stages/(?<stage_idx>\d+)-(?<stage_name>[a-z][a-z0-9-]*)/(?<slug>[a-z][a-z0-9-]{0,62}[a-z0-9])/?\z}
+    # Accepts both the canonical `.hive/` scaffold root and the legacy
+    # `.hive-state/` one (read-only back-compat, plan U2). The captured
+    # +state_dir+ name tells downstream code which layout the folder
+    # actually lives in.
+    PATH_RE = %r{\A(?<root>.+)/(?<state_dir>\.hive(?:-state)?)/stages/(?<stage_idx>\d+)-(?<stage_name>[a-z][a-z0-9-]*)/(?<slug>[a-z][a-z0-9-]{0,62}[a-z0-9])/?\z}
 
     attr_reader :folder, :project_root, :hive_state_path, :stage_index,
                 :stage_name, :slug, :state_dir_basename
@@ -22,7 +27,11 @@ module Hive
     def initialize(folder)
       folder = File.expand_path(folder)
       m = PATH_RE.match(folder)
-      raise InvalidTaskPath, "task path must match <project>/.hive-state/stages/<N>-<name>/<slug>/: #{folder}" unless m
+      unless m
+        raise InvalidTaskPath,
+              "task path must match <project>/.hive/stages/<N>-<name>/<slug>/ " \
+              "(legacy <project>/.hive-state/stages/... accepted): #{folder}"
+      end
       stage_dir = "#{m[:stage_idx]}-#{m[:stage_name]}"
       unless STAGE_NAMES.include?(m[:stage_name]) && Hive::Stages.parse(stage_dir)
         raise InvalidTaskPath, "unknown stage name: #{stage_dir}; run `hive migrate` if this task uses pre-open-pr stage names"
@@ -41,6 +50,13 @@ module Hive
       File.basename(@project_root)
     end
 
+    # True when this task's scaffold lives under the legacy `.hive-state`
+    # root. Commands with user-facing entry points print a one-line
+    # notice for such trees (see Hive.announce_legacy_project_dir!).
+    def legacy_state_dir?
+      @state_dir_basename == Hive::LEGACY_PROJECT_DIR
+    end
+
     def state_file
       File.join(@folder, STATE_FILES.fetch(@stage_name))
     end
diff --git a/lib/hive/task_resolver.rb b/lib/hive/task_resolver.rb
index c496bd8..d1012ee 100644
--- a/lib/hive/task_resolver.rb
+++ b/lib/hive/task_resolver.rb
@@ -25,6 +25,7 @@ module Hive
     def resolve
       folder = resolve_folder
       task = Hive::Task.new(folder)
+      Hive.announce_legacy_project_dir!(task.hive_state_path)
       validate_project_path_match!(task)
       validate_stage_match!(task)
       task
diff --git a/packaging/PKGBUILD b/packaging/PKGBUILD
new file mode 100644
index 0000000..6ff0e37
--- /dev/null
+++ b/packaging/PKGBUILD
@@ -0,0 +1,46 @@
+# Maintainer: hive release bot <release-bot@users.noreply.github.com>
+# Upstream plan: figure-out-way-to-install (U9). -bin packages ship
+# upstream-provided binaries with checksums only — no source builds.
+pkgname=hive-bin
+pkgver=1.2.3
+pkgrel=1
+pkgdesc="Autonomous software-delivery pipeline driven by coding agent CLIs"
+arch=('x86_64')
+url="https://github.com/ivankuznetsov/hive"
+license=('MIT')
+depends=('bash' 'git')
+optdepends=('yay: AUR helper used by `hive update`'
+            'paru: alternative AUR helper used by `hive update`'
+            'systemd: per-user daemon service unit')
+provides=('hive')
+conflicts=('hive-hive-bin' 'hive-git')
+source=("hive-${pkgver}.tar.gz::https://github.com/ivankuznetsov/hive/releases/download/v${pkgver}/hive-v${pkgver}-linux-x86_64.tar.gz")
+sha256sums=(# STAMPED)
+
+# FHS-correct for system packages (plan U9): binary to /usr/bin, shared
+# assets to /usr/share/hive. Hive::Paths falls back through
+# HIVE_ASSETS_DIR → ~/.local/share/hive when the per-user layout is absent.
+package() {
+  cd "${srcdir}/${pkgname%-bin}-v${pkgver}-linux-x86_64" 2>/dev/null ||
+    cd "${srcdir}/hive-v${pkgver}-linux-x86_64"
+
+  install -Dm755 bin/hive "$pkgdir/usr/bin/hive"
+  if [[ -d share ]]; then
+    cp -R share "$pkgdir/usr/share/hive"
+    find "$pkgdir/usr/share/hive" -type d -exec chmod 755 {} +
+    find "$pkgdir/usr/share/hive" -type f -exec chmod 644 {} +
+    # bin/hive inside the payload stays executable for direct invocation.
+    [[ -f "$pkgdir/usr/share/hive/bin/hive" ]] && chmod 755 "$pkgdir/usr/share/hive/bin/hive"
+  fi
+
+  install -Dm644 /dev/null "$pkgdir/usr/share/licenses/${pkgname}/LICENSE"
+}
+
+post_install() {
+  echo "==> next steps: run 'hive init' inside a project, and consider"
+  echo "    systemctl --user enable --now hive.service   (or let hive init do it)"
+}
+
+pre_remove() {
+  :
+}
diff --git a/packaging/aur/.SRCINFO b/packaging/aur/.SRCINFO
new file mode 100644
index 0000000..af25b64
--- /dev/null
+++ b/packaging/aur/.SRCINFO
@@ -0,0 +1,17 @@
+pkgbase = hive-bin
+pkgname = hive-bin
+pkgver = 0.1.0
+pkgrel = 1
+pkgdesc = Autonomous software-delivery pipeline driven by coding agent CLIs
+url = https://github.com/ivankuznetsov/hive
+arch = x86_64
+license = MIT
+optdepends = yay: AUR helper used by hive update
+optdepends = paru: alternative AUR helper used by hive update
+optdepends = systemd: per-user daemon service unit
+conflicts = hive-hive-bin
+conflicts = hive-git
+provides = hive
+source = hive-0.1.0.tar.gz::https://github.com/ivankuznetsov/hive/releases/download/v0.1.0/hive-v0.1.0-linux-x86_64.tar.gz
+sha256sums = SKIP
+pkgdesc-detail: regenerated automatically by packaging/gen_pkgbuild.sh (makepkg --printsrcinfo)
diff --git a/packaging/aur/PKGBUILD b/packaging/aur/PKGBUILD
new file mode 100644
index 0000000..9521285
--- /dev/null
+++ b/packaging/aur/PKGBUILD
@@ -0,0 +1,40 @@
+# Maintainer: hive release bot <release-bot@users.noreply.github.com>
+# TEMPLATE — stamped by packaging/gen_pkgbuild.sh (version + sha256sums).
+pkgname=hive-bin
+pkgver=1.2.3
+pkgrel=1
+pkgdesc="Autonomous software-delivery pipeline driven by coding agent CLIs"
+arch=('x86_64')
+url="https://github.com/ivankuznetsov/hive"
+license=('MIT')
+depends=('bash' 'git')
+optdepends=('yay: AUR helper used by `hive update`'
+            'paru: alternative AUR helper used by `hive update`'
+            'systemd: per-user daemon service unit')
+provides=('hive')
+conflicts=('hive-hive-bin' 'hive-git')
+source=("hive-${pkgver}.tar.gz::https://github.com/ivankuznetsov/hive/releases/download/v${pkgver}/hive-v${pkgver}-linux-x86_64.tar.gz")
+sha256sums=('5f2a9b7cdeadbeef')
+
+package() {
+  cd "${srcdir}/hive-v${pkgver}-linux-x86_64"
+
+  install -Dm755 bin/hive "$pkgdir/usr/bin/hive"
+  if [[ -d share ]]; then
+    cp -R share "$pkgdir/usr/share/hive"
+    find "$pkgdir/usr/share/hive" -type d -exec chmod 755 {} +
+    find "$pkgdir/usr/share/hive" -type f -exec chmod 644 {} +
+    [[ -f "$pkgdir/usr/share/hive/bin/hive" ]] && chmod 755 "$pkgdir/usr/share/hive/bin/hive"
+  fi
+
+  install -Dm644 /dev/null "$pkgdir/usr/share/licenses/${pkgname}/LICENSE"
+}
+
+post_install() {
+  echo "==> next steps: run 'hive init' inside a project, and consider"
+  echo "    systemctl --user enable --now hive.service   (or let hive init do it)"
+}
+
+pre_remove() {
+  :
+}
